#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "InpOut32.h"
#include "track_uploader_private.h"

/*declarations imported from header*/
int InitGSComms(void);
int CloseGSComms(void);
int UploadFile(FILE * infile, unsigned long address);
int GSFcn1(int);
int SendNibble(int);
int ReadWriteNibble(int);
int ReadWriteByte(int);
unsigned int ReadWrite16(unsigned int x);
unsigned long ReadWrite32(unsigned long);
int CheckGSPresence(void);
unsigned long Read32(unsigned long address);
unsigned char ReadByte(unsigned long address);
int Write32(unsigned long address,unsigned long value);
int Write16(unsigned long address,unsigned short value);
int WriteByte(unsigned long address,unsigned char value);
int checkered(unsigned long *selected);
int erratta(int code);

/*Sorry ahead of time.  I'm a rambler
F-Zero X Track Uploader v1.0
c/o Zoinkity (nefariousdogooder@yahoo.com)

A cute little console app that can replace courses on the console game with , well, anything.
Sorry in advance if you hate console apps.  Feel free to port this or write your own!
The upload code is based on hcs's generic comms as used in Neon64
http://sourceforge.net/projects/N64dev

This uses InpOut32.dll, which should either be with the program or in your windows System or System32 folder.
Why?  Because winXP buggered the comms port, that's why.

This thing uploads courses to (at least) the North American F-Zero X release
ordinary format is:
         0x7E0 of track info
         0x20  track name string, null terminated (overkill)
         0x20  track description, null terminated (overkill)
Once the editor is released then converting that format shouldn't be impossible
Up to 26 stages can be replaced.  In other words, all of them;*)

Japanese and European are not supported at this time.  Once I can test them, maybe then.
At the moment a "fake" checksum is pulled from the rom to see if it is the correct region.
Unsupported games should not be allowed.

Japanese text locations are 800e4170 and 80118D58.  There is enough room in the .asm for all level text
Text can be sent seperately from the other binary.
Text values are standard N64 Japanese (pushed windows-932, though they use a small subset.  Alpha, Beta, and Gamma are included)
Not sure on PAL.

The N64-side ASM is inefficiently written, but in all honesty I've got room to spare
Clarity and ease of editing was the goal, and quite honestly setting some absurd loop,
MULTI-ing the address and all...  it's an awful lot of fuss when it really isn't necessary.
In all honesty you don't need the #tracks loaded value, but asm does need to be word-aligned
Loaded stages also don't need to be in prescribed locations for this setup.

The control block is uploaded to 80500000, and contains the asm, # stages modded,
     and a list of which stages are being replaced by the given course
On activation, read the word at 800741C0.  If this does not read 0C01D10A,
   upload the control block and set 810741C0 to 0C140008 (sets jump to 80500020)
This first 0x20 of data should be read to ensure the same course is not replaced twice
     and that you still have some room left.  Only the first stage replacement will occur.
     
On adding a course, upload the course to the proper address (see below),
     set the track number being replaced to the corresponding spot,
     set the text pointers (see below),
     and increment the number of tracks being replaced.
     You may want to set it to the first slot with FF as a track number
To delete courses, decrement the track # value.
   Set the track value for the replaced track to FF
   and reset the text pointers (see below).
   There is no trouble copying over an existing course with another.
So, why isn't deleting implemented here?  I'm inherantly lazy

Courses are uploaded starting at 805003A0.  Each course follows +0x820
The course addresses correspond to the slot the track number is designated to
In other words, course 0 is at 805003A0, replacing the track # at 80500006
   course 1 is at 80500BC0, replacing the track at 80500007, etc.
The track numbers are:
    0-5     Jack Cup Courses
    6-B     Queen Cup Courses
    C-11    King Cup Courses
    12-17   Joker Cup Courses
    18-1D   currently unplayable      Default, to be technical, but replaced with either Edit Cup 1 or DD1 courses
    1E-23   currently unplayable      Edit Cup 2 or DD2 courses
    24-29   currently unplayable      DD1 or Edit Cup 1 courses
    2A-2F   currently unplayable      DD2 or Edit Cup 2 courses
    30-35   X Cup Courses, though these can't be replaced
    36      The Death Race course
    37      The course played at the end of a cup
    
The text strings should be null terminated.
    Both are much longer than required so if anyone does something stupid like
    feed it a line vastly too large to fit a Null, quite honestly it wouldn't
    display on the screen anyway.
The stage name is always address+0x7E0 and the description address+0x800
Set the stage name pointer at 800E4180.  These are constant
descriptions are at 801194C8.  These are not
we'll replace them with a copy of the table at 80500188
here's the trick:
       These are only pointer tables some of the time.  Use the code generator
       to get around it.  For this we use uncached memory, so addresses are A0, not 80
       set A07E9D60 to the number of codes you want active
           You want to add four, but check that no others are present.
       You will send eight codes for total text replacement.
       First is a D1 to check for the original values
       Second is a 81 replacement value
       D11185DA 8012
       811185DA 8050
       D11185E6 94C8
       811185E6 0188
       D111861E 8012
       8111861E 8050
       D1118630 94C8
       81118630 0188
       This should effectively move both references to the table
Replacing the text is the mere matter of replacing the pointer.

Initilizing the comms stops play.  Reinitilize between read/write operations
Close the comms only after all data has been uploaded
There isn't any harm in sending a debug zero before and after program execution

Needless to say, you can do an awful lot more with this than I had.
Feel free, by the way.  That's what this source was here for in the first place.
You can easily implement changing a loaded course's backgrounds and such

It probably would be a good idea to implement zlib to read compressed files...
Oh well.
Blah. now to the program
*/

/*this is a slight convenience
it keeps track of whether the comms are connected 1=no, 0=yes
most times this isn't necessary, but it helps when aborting the program*/
int stateflag=1;

/*warning - this will probably get very ugly...*/
int main(int argc, char *argv[])
{int num,c,y;
unsigned long x=0,selected=0;
FILE *in;
char filename[120];

printf("\nReady to contact your GS!\n");
system("PAUSE");

for(;;)
{
/*check to see if basic upload routine is embedded*/
/*if there are any stage numbers to read, read them now*/
num=checkered(&selected);
x=0;

for(c=0;c==0;)                    /*this is the main menu loop*/
{if(x>0) selected= ~selected;
x=0;
for(c=0;c==0;)                    /*this loop is for the Cup select*/
{system("CLS");
printf("\nF-Zero X Track Uploader v1.0 (console)\nc/o Zoinkity (nefariousdogooder@yahoo.com)\n");
fflush(stdin);
/*Ugly!*/
if(x==0)/*if no more courses for normal, switch to replace*/
{if(num>25)
   {x=1; selected=~selected;}
}
if(x>0) printf("\n-%s Stage-\t",x>1 ? "Deleting":"Replacing Loaded");
printf("\nSelect a cup:");
printf("%s",(selected & 0x0000003F)==0x3F ? "":"\n1:  Jack Cup");
printf("%s",(selected & 0x00000FC0)==0xFC0 ? "":"\n2: Queen Cup");
printf("%s",(selected & 0x0003F000)==0x3F000 ? "":"\n3:  King Cup");
printf("%s",(selected & 0x00FC0000)==0xFC0000 ? "":"\n4: Joker Cup");
printf("%s",(selected & 0x03000000)==0x3000000 ? "":"\n5:  Etc.");

if(x==0)
{printf("\n6: Reprobe Level List");
if(selected>0) printf("\n7: Replace Previously Loaded Stage\n8: Remove Loaded Course");
}
if(x==1)
{if(num<26) printf("\n7: Return to Main Menu");
printf("\n8: Remove Loaded Course");}
if(x==2)
{printf("\n7: Replace Previously Loaded Stage");
if(num<26) printf("\n8: Return to Main Menu");
printf("\n\n(note: deleted courses will not display correct text)");}

printf("\n\nAny Other Key - Exit\n");
switch(getchar())
      {case '1':
            if((selected & 0x0000003F)==0x3F) continue;
            c=1;
            break;
      case '2':
           if((selected & 0x00000FC0)==0xFC0) continue;
           c=2;
           break;
      case '3':
           if((selected & 0x0003F000)==0x3F000) continue;
           c=3;
           break;
      case '4':
           if((selected & 0x00FC0000)==0xFC0000) continue;
           c=4;
           break;
      case '5':
           if((selected & 0x03000000)==0x3000000) continue;
           c=5;
           break;     
      case '6':
           if(x<1) c=6;
           break;
      case '7':
           if(x==1)
             {x=0; selected= ~selected; continue;}
           if(x==2)
             {x=1; break;}
           if(selected>0)
             {x=1; selected= ~selected;}
           break;
      case '8':
           if(x==2)
             {x=0; selected= ~selected; continue;}
           if(x==1)
             {x=2; break;}
           if(selected>0)
           {x=2; selected= ~selected;}
           break;
      default:
              return 0;
              break;
      }
}/*end cup select*/
fflush(stdin);
while(c==1)/*now to just edit all of these...*/
{
system("CLS");
printf("\nF-Zero X Track Uploader v1.0 (console)\nc/o Zoinkity (nefariousdogooder@yahoo.com)\n");
if(x>0) printf("\n-%s Stage-",x>1 ? "Deleting":"Replacing Loaded");
printf("\nSelect the stage you wish to replace:");
printf("%s",selected & 0x00000001 ? "":"\n1: Jack1: Mute City");
printf("%s",selected & 0x00000002 ? "":"\n2: Jack2: Silence");
printf("%s",selected & 0x00000004 ? "":"\n3: Jack3: Sand Ocean");
printf("%s",selected & 0x00000008 ? "":"\n4: Jack4: Devil's Forest");
printf("%s",selected & 0x00000010 ? "":"\n5: Jack5: Big Blue");
printf("%s",selected & 0x00000020 ? "":"\n6: Jack6: Port Town");
printf("\n\n0: Back to Main Menu\n");
switch(getchar())
      {case '0':
            c=0; continue; break;
      case '1':
            if(selected & 0x00000001) continue;
            y=0; c=9;
            break;
      case '2':
           if(selected & 0x00000002) continue;
           y=1; c=9;
           break;
      case '3':
           if(selected & 0x00000004) continue;
           y=2; c=9;
           break;
      case '4':
           if(selected & 0x00000008) continue;
           y=3; c=9;
           break;
      case '5':
           if(selected & 0x00000010) continue;
           y=4; c=9;
           break;     
      case '6':
           if(selected & 0x00000020) continue;
           y=5; c=9;
           break;
      }
}
while(c==2)
{
system("CLS");
printf("\nF-Zero X Track Uploader v1.0 (console)\nc/o Zoinkity (nefariousdogooder@yahoo.com)\n");
printf("\nSelect the stage you wish to replace:");
printf("%s",selected & 0x00000040 ? "":"\n1: Queen1: Sector Alpha");
printf("%s",selected & 0x00000080 ? "":"\n2: Queen2: Red Canyon");
printf("%s",selected & 0x00000100 ? "":"\n3: Queen3: Devil's Forest 2");
printf("%s",selected & 0x00000200 ? "":"\n4: Queen4: Mute City 2");
printf("%s",selected & 0x00000400 ? "":"\n5: Queen5: Big Blue 2");
printf("%s",selected & 0x00000800 ? "":"\n6: Queen6: White Land");
printf("\n\n0: Back to Main Menu\n");
switch(getchar())
      {case '0':
            c=0; continue; break;
      case '1':
            if(selected & 0x00000040) continue;
            y=6; c=9;
            break;
      case '2':
           if(selected & 0x00000080) continue;
           y=7; c=9;
           break;
      case '3':
           if(selected & 0x00000100) continue;
           y=8; c=9;
           break;
      case '4':
           if(selected & 0x00000200) continue;
           y=9; c=9;
           break;
      case '5':
           if(selected & 0x00000400) continue;
           y=10; c=9;
           break;     
      case '6':
           if(selected & 0x00000800) continue;
           y=11; c=9;
           break;
      }
}
while(c==3)
{
system("CLS");
printf("\nF-Zero X Track Uploader v1.0 (console)\nc/o Zoinkity (nefariousdogooder@yahoo.com)\n");
printf("\nSelect the stage you wish to replace:");
printf("%s",selected & 0x00001000 ? "":"\n1: King1: Fire Field");
printf("%s",selected & 0x00002000 ? "":"\n2: King2: Silence 2");
printf("%s",selected & 0x00004000 ? "":"\n3: King3: Sector Beta");
printf("%s",selected & 0x00008000 ? "":"\n4: King4: Red Canyon 2");
printf("%s",selected & 0x00010000 ? "":"\n5: King5: White Land 2");
printf("%s",selected & 0x00020000 ? "":"\n6: King6: Mute City 3");
printf("\n\n0: Back to Main Menu\n");
switch(getchar())
      {case '0':
            c=0; continue; break;
      case '1':
            if(selected & 0x00001000) continue;
            y=12; c=9;
            break;
      case '2':
           if(selected & 0x00002000) continue;
           y=13; c=9;
           break;
      case '3':
           if(selected & 0x00004000) continue;
           y=14; c=9;
           break;
      case '4':
           if(selected & 0x00008000) continue;
           y=15; c=9;
           break;
      case '5':
           if(selected & 0x00010000) continue;
           y=16; c=9;
           break;     
      case '6':
           if(selected & 0x00020000) continue;
           y=17; c=9;
           break;
      }
}
while(c==4)
{
system("CLS");
printf("\nF-Zero X Track Uploader v1.0 (console)\nc/o Zoinkity (nefariousdogooder@yahoo.com)\n");
printf("\nSelect the stage you wish to replace:");
printf("%s",selected & 0x00040000 ? "":"\n1: Joker1: Rainbow Road");
printf("%s",selected & 0x00080000 ? "":"\n2: Joker2: Devil's Forest 3");
printf("%s",selected & 0x00100000 ? "":"\n3: Joker3: Space Plant");
printf("%s",selected & 0x00200000 ? "":"\n4: Joker4: Sand Ocean 2");
printf("%s",selected & 0x00400000 ? "":"\n5: Joker5: Port Town 2");
printf("%s",selected & 0x00800000 ? "":"\n6: Joker6: Big Hand");
printf("\n\n0: Back to Main Menu\n");
switch(getchar())
      {case '0':
            c=0; continue; break;
      case '1':
            if(selected & 0x00040000) continue;
            y=18; c=9;
            break;
      case '2':
           if(selected & 0x00080000) continue;
           y=19; c=9;
           break;
      case '3':
           if(selected & 0x00100000) continue;
           y=20; c=9;
           break;
      case '4':
           if(selected & 0x00200000) continue;
           y=21; c=9;
           break;
      case '5':
           if(selected & 0x00400000) continue;
           y=22; c=9;
           break;     
      case '6':
           if(selected & 0x00800000) continue;
           y=23; c=9;
           break;
      }
}
while(c==5)
{
system("CLS");
printf("\nF-Zero X Track Uploader v1.0 (console)\nc/o Zoinkity (nefariousdogooder@yahoo.com)\n");
printf("\nSelect the stage you wish to replace:");
printf("%s",selected & 0x01000000 ? "":"\n1: Death Race");
printf("%s",selected & 0x02000000 ? "":"\n2: Ending");
printf("\n\n0: Back to Main Menu\n");
switch(getchar())
      {case '0':
            c=0; continue; break;
      case '1':
            if(selected & 0x01000000) continue;
            y=0x36; c=9;
            break;
      case '2':
           if(selected & 0x02000000) continue;
           y=0x37; c=9;
           break;
      }
}

}/*End Main Menu*/
c-=x;

if(c==7)/*delete routine*/
{/*remove reference to level*/
num = y - (30*(y>24));/*num = replacement slot*/
if(y<30)  /*if a text sample, grab the reset value*/
{/*if(!(in= fopen("fudge.asm", "rb"))) erratta(3);
fseek(in,0x188 + (4 * num),SEEK_SET);
*/}
InitGSComms();
ReadWriteByte(2);
WriteByte(0x80500006+num,0xFF);
/*todo: reset text pointers*/
if(y<30)
{}
ReadWrite32(0);
ReadWrite32(0);
CloseGSComms();
}

if(c>7)/*upload stuff*/
{
/*grab filename*/
	strcpy(filename,"\0");
    while (!(in = fopen(filename, "rb"))) {
	printf("\nWhat would you like to replace it with? ");
    fflush(stdin);
	strcpy(filename,"\0");	
	gets(filename);
    }

num = y - (30*(y>24));/*num = replacement slot*/
x=0x805003A0 + (num * 0x820);
UploadFile(in,x);   /*upload course*/
fclose(in);
InitGSComms();
ReadWriteByte(2);
WriteByte(0x80500006+num,(unsigned char)y);
if(y<30)                           /*text mods*/
        {Write32(0x80500188+(y * 4),x+0x800);
        Write32(0x800E4180+(y * 4),x+0x7E0);
        }
ReadWrite32(0);
ReadWrite32(0);
CloseGSComms();
}/*that's it for the stage!*/

}/*kill the infinite for() loop of doom*/
}/*End main()*/



/*checks if upload routine embedded
if not, does it for you
returns number of tracks already loaded*/
int checkered(unsigned long *selected)
{FILE *in;
unsigned long addy,x;
int num,c;
unsigned char y;

InitGSComms();
ReadWriteByte(1);
/*NTSC North America & Japan
however, the text locations are different for japan
you could check the rom header for region, or anything different really*/
if(Read32(0x800741C0)==0x0C01D10A)
  {printf("\nWait a second while the game is patched to allow course uploading.\n");
  addy=Read32(0xA07E9D60);
  if(Read32(0xB0000010)!=0xB30E3003) erratta(6);/*do fakey checksum check for region*/
  ReadWrite32(0);
  ReadWrite32(0);
  if(!(in=fopen("fudge.asm","rb"))) erratta(3);
  UploadFile(in,0x80500000);
  fclose(in);
  x=(addy * 6) + 0xA07E9D64;
  InitGSComms();
  ReadWriteByte(2);
  Write32(0x800741C0,0x0C140008);
  /*text replacement stuff*/
  Write32(x,0xD11185DA);
  Write16(x+4,0x8012);
  Write32(x+6,0x811185DA);
  Write16(x+10,0x8050);
  Write32(x+12,0xD11185E6);
  Write16(x+16,0x94C8);
  Write32(x+18,0x811185E6);
  Write16(x+22,0x0188);
  Write32(x+24,0xD111861E);
  Write16(x+28,0x8012);
  Write32(x+30,0x8111861E);
  Write16(x+34,0x8050);
  Write32(x+36,0xD1118632);
  Write16(x+40,0x94C8);
  Write32(x+42,0x81118632);
  Write16(x+46,0x0188);
  Write32(0xA07E9D60,addy+8);
  ReadWrite32(0);
  ReadWrite32(0);
  InitGSComms();
  ReadWriteByte(1);
  }
/*insert other region codes here*/

/*check that the correct game is loaded and patched properly*/
if(Read32(0x800741C0)!=0x0C140008)
  {ReadWrite32(0);ReadWrite32(0);
  erratta(6);}

/*if patched, rip the course info*/
printf("\nOne second.\nJust figuring out which courses have been replaced so far.\n");
*selected=0;
num=0;/*compute number of courses loaded*/
  ReadWrite32(0x80500006);
  ReadWrite32(26);/*grab all the stage numbers for the replaced courses*/
  for(c=0;c<26;c++)
     {y=ReadWriteByte(0);
     /*exp would be nice, but I need a binary value not float*/
     if(y==0xFF) continue;/*null course number*/
     else if(y==0x37) *selected|=0x02000000;
     else if(y==0x36) *selected|=0x01000000;
     else {x=1;
          for(addy=0;addy<y;addy++) x*=2;
          *selected|=x;}
     num++;
     }

ReadWrite32(0);
ReadWrite32(0);
/*not necessary, but writes the number of courses loaded back to GS*/
InitGSComms();
ReadWriteByte(2);
Write16(0x80500004,(unsigned short)num);/*number of courses loaded*/
ReadWrite32(0);
ReadWrite32(0);
CloseGSComms();
return num;}

int erratta(int code)
{switch(code)
       {default:/*unspecified for some reason*/
                break;
       case 0:  /*why did you call this again?*/
            return 0;
            break;
       case 1: /*failed init - timeout*/
             fprintf(stderr,"\nTimeout Error!\n");
             fprintf(stderr,"\nCan't connect to GS.\nCheck your cable and make sure code generator is ON.\nIf you're in the GS menus, exit them and try again");
             break;
       case 2:     /*failed init - Comms Not Detected*/
            fprintf(stderr,"\nComms Not Detected!\n");            
            fprintf(stderr,"\nCan't connect to GS.\nCheck your cable and make sure code generator is ON.\nIf you're in the GS menus, exit them and try again");
            break;
       case 3:    /*can't find/open fudge.asm*/
            fprintf(stderr,"\nCan't Find fudge.asm!\n");
            fprintf(stderr,"\nThis should be in the same folder as this program.\nTry finding it and place it in this folder, then run the program again.\n\nThis is a console program, so the directory leading to the file may be too long.\nSet this stuff as close to your drive letter as possible.\n");
            break;
       case 4:    /*shorten up your filenames! - nonterminal*/
            fprintf(stderr,"\nThat file is grumpy.  It couldn't be opened properly.\n");
            fprintf(stderr,"\nThe directory leading to the file may be too long.\nSet this stuff as close to your drive letter as possible.\nThis is a console program after all\n");
            return 0;
            break;
       case 5:    /*can't let go of comms*/
            fprintf(stderr,"\nThe comms are buggered so they can't be disconnected\nSorry to say, you'll likely need to restart the game\nsorry for the inconvenience...\n");
            break;
       case 6:    /*Wrong game, or at least wrong version*/
            fprintf(stderr,"\nHmm...  Either this isn't F-Zero X, you have an unsupported version of the game, or the patch failed miserably.");
/*supported*/            fprintf(stderr,"\nOnly the North American F-Zero X game is fully supported at this time.");
            fprintf(stderr,"\nGrab the correct game and try again!\n");
            break;
       }

CloseGSComms();
Out32(LPT1,0);
fprintf(stderr,"\naborting...\n");
system("PAUSE");
exit(1);
}

/*****************************************
Generic comms functions courtesy of hcs
http://sourceforge.net/projects/N64dev
nifty, eh?
*****************************************/

/*call to initialize comms
This locks the game and allows PC access
You must re-initialize between read/write to reset pipe*/
int InitGSComms(void) {
	int timeout=0x80;/*change this to fiddle with general timeout value*/
	while (GSFcn1(3) && timeout) {
		timeout--;
		/*15 second warning...*/
		if(timeout==0x20) printf("\napprox seconds remaining before timeout:   %2d",timeout);
		if(timeout<=0x20) printf("\b\b%2d",timeout);
	}
	if (!timeout) erratta(1);
	if (!CheckGSPresence()) erratta(2);
	stateflag=0;
    return 0;
}

/*closing comms cuts the stream.  
You only really need to do it when all access is complete
Therefore, read&write all day long, then kill stream at the very end*/
int CloseGSComms(void) {
    if (stateflag) return 0;
    stateflag=1;
	if (GSFcn1(3)|(!CheckGSPresence())) erratta(5);
	ReadWriteByte(0x64);
    Out32(LPT1,0);      /*blank out the LPT*/
    return 0;
}

/*checks for sync*/
int GSFcn1(int x) {
	int timeout=0x28;
	unsigned char result;
	
	while (timeout) {
		result<<=4;
		result|=SendNibble(x);
		// when we recieve a 6, then a 7, we're sync'd
		if (result==0x67) break;

		SendNibble(x);
		SendNibble(x>>4);

		timeout--;
	}

	if (!timeout) return 1;
	return 0;
}

int SendNibble(int x) {
	int timeout=0x3e8,retval;
	
	Out32(LPT1,x&0xf|0x10);

	while (timeout && Inp32(LPT1+1)&8) timeout--;
	
	retval=(Inp32(LPT1+1)&0xf0^0x80)>>4;

	Out32(LPT1,0);

	timeout=0x64;
	while (timeout && Inp32(LPT1+1)&8) timeout--;

	if (!timeout) return 0;
	else return retval;
}

int ReadWriteNibble(int x) {
	int retval;
	Out32(LPT1,x&0xf|0x10);
	
	while ((~Inp32(LPT1+1))&8);
	while ((~Inp32(LPT1+1))&8);

	retval=(Inp32(LPT1+1)&0xf0^0x80)>>4;

	Out32(LPT1,0);

	while (Inp32(LPT1+1)&8);
	while (Inp32(LPT1+1)&8);

	return retval;
}

int ReadWriteByte(int x) {
	return (ReadWriteNibble(x>>4)<<4)|ReadWriteNibble(x);
}

unsigned int ReadWrite16(unsigned int x) {
	return ((ReadWriteNibble(x>>12)<<12)|(ReadWriteNibble(x>>8)<<8)|(ReadWriteNibble(x>>4)<<4)|ReadWriteNibble(x));
}

unsigned long ReadWrite32(unsigned long x) {
	return ((unsigned long)ReadWriteNibble(x>>28)<<28)|((unsigned long)ReadWriteNibble(x>>24)<<24)|((unsigned long)ReadWriteNibble(x>>20)<<20)|((unsigned long)ReadWriteNibble(x>>16)<<16)|((unsigned long)ReadWriteNibble(x>>12)<<12)|((unsigned long)ReadWriteNibble(x>>8)<<8)|((unsigned long)ReadWriteNibble(x>>4)<<4)|(unsigned long)ReadWriteNibble(x);
}

/* this breaks when the GS can allow ram access*/
int CheckGSPresence(void) {
	int timeout=0x3e8,result;
	
	while (timeout) {
		result=(ReadWriteNibble(0x47>>4)<<4)|ReadWriteNibble(0x47);
		timeout--;
		if (result != 0x67) continue;
		result=(ReadWriteNibble(0x54>>4)<<4)|ReadWriteNibble(0x54);
		if (result == 0x74) break;
	}

/*	printf("\nGS utilities can't be used while in the GS menu.\n");*/
	if (timeout) return 1;
	return 0;
}

int UploadFile(FILE * infile, unsigned long address) {
	unsigned long c=0;
	unsigned long size;
	char buf;
	
	fseek(infile,0,SEEK_END);
	size=ftell(infile);
	rewind(infile);
    if(size<=0) return 2;
	InitGSComms();

	printf("\nUploading...00%%");

	ReadWriteByte(2);
	ReadWrite32(address);
	ReadWrite32(size);
	
	for (c=0; c < size; c++) {
		fread(&buf,1,1,infile);
		if (c & 0x400) printf("\b\b\b%2d%%",c*100/size);
		ReadWriteByte(buf);
	}
    ReadWrite32(0);
    ReadWrite32(0);/*end of transfer*/
	printf("\b\b\bDone.\n");
	
	return 0;
}

/*these are simple read/write types as above, but don't initiate or close the comms
  heck, they could probably just be implemented as macros if you get right to it...
  These are slightly faster, but the others are more robust*/
unsigned long Read32(unsigned long address) {
	unsigned long value=0;
	
	ReadWrite32(address);
	ReadWrite32(4);
	
	value=ReadWrite32(0);

	return value;
}

int Write32(unsigned long address,unsigned long value) {
	
	ReadWrite32(address);
	ReadWrite32(4);
	
	ReadWrite32(value);

	return 0;
}


int Write16(unsigned long address,unsigned short value) {
	
	ReadWrite32(address);
	ReadWrite32(2);
	
	ReadWrite16(value);

	return 0;
}

unsigned char ReadByte(unsigned long address)
{ReadWrite32(address);
ReadWrite32(1);
return ReadWriteByte(0);
}

int WriteByte(unsigned long address,unsigned char value)
{ReadWrite32(address);
ReadWrite32(1);
ReadWriteByte(value);
return 0;
}
